#include <stdio.h>
#include "cOfficer.h"

static const int officer_snum = 3;
static int   officer_narr[officer_snum] = {0, 1, 2};
static char* officer_carr[officer_snum] = {"DREAM", "ORDER", "OBSRV"};


COfficer::COfficer(CSQueue *queue, FILE *f_rec)
:CSAutomate(queue, "A1   ", new CSStateArray(officer_snum,  officer_narr, officer_carr), f_rec, true)
{
	
}


//    A1
void COfficer::A(CSMessage &msg)
{
	int ev = Translate(msg);
	switch (y_o) {
	case 0: 
		if (ev == 1)	{ y_n = 1; action = 1; }
		break;
	
	case 1: 
		if (ev == 2)	{ y_n = 2; }
		break;

	case 2: 
		if (ev == 3)	{ y_n = 0; }
	}
}


// ,   A1
void COfficer::S()
{
	switch (action) {
	case 1: z1();
	}
}


//  
int COfficer::Translate(CSMessage &msg)
{
	if (msg.id == 1 && msg.src == -1) return 1;
	if (msg.id == 2 && msg.src ==  1) return 2;
	if (msg.id == 3 && msg.src ==  1) return 3;
	return 0;
}

void COfficer::z1()
{
	Queue->AddMessage(new CSMessage(1, 0));
}

